/* IRCfs - IRC FileServ for *nix.
 * Copyright (C) 2002  Nick 'Zaf' Clifford <zaf@nrc.co.nz>
 * For licensing details, refer to the LICENSE file in the source
 * code directory.
 */
#ifndef __include_internal_h__
#define __include_internal_h__

struct conf_group {
	const char *name;
	struct str_hash_table *settings;
};

struct conf_value {
	enum conf_type type;		//Expected/Guessed type
	void *data;			//Type data
	struct conf_group *group;	//Group the value is in
};

int conf_print_hash_value(struct str_hash_table *, const char *name,
				struct conf_value *cv, void *appdata);
int conf_print_group(struct list *, struct conf_group *cg, void *);
	
int conf_print_settings();

struct conf_group *conf_create_group(struct conf_group *parent,
		const char *name);
struct conf_group *conf_open_group(struct conf_group *parent,
		const char *name);

struct conf_item *conf_find_item(struct conf_group *cg,const char *name);
extern struct conf_group *conf_root_group;
extern POOL conf_pool;
extern DEBUG conf_debug;
extern int conf_ran_init;

struct conf_value *conf_value_dup(POOL p, struct conf_value *cv);

int appconf_init();

#endif
