#!/bin/sh
# IRCfs - IRC FileServ for *nix.
# Copyright (C) 2002  Nick 'Zaf' Clifford <zaf@nrc.co.nz>
# For licensing details, refer to the LICENSE file in the source 
# code directory.




if [ "$1" = "-v" ]; then
	verbose=1
	shift
fi
if [ ! -f $1 ]; then
	echo "$0 <files to scan>";
	exit 2;
fi
srcdir=`echo $0 | awk '{ n=split($0,a,"\/"); for(i = 1; i < n; i++) { printf ("%s/",a[i]); } print "" }'`
if [ "$srcdir" = "$0" -o "$srcdir" = "" ]; then
	echo "Please call script by path";
	exit 2;
fi
echo "$srcdir";

for file in $*; do
	if [ "$verbose" -ge "2" ]; then
		echo -n "Scanning $file: "
	fi
	sed -n 's/^[ \t]*MODULE_REGISTER\((.*)\).*/MODULE_LIST\1/p' \
		< $file >> $srcdir/modlist.h 
	sed -n 's/^[ \t]*MODULE_POST\((.*)\).*/MODULE_POST\1/p' \
		< $file >> $srcdir/modpost.h
	if [ "$verbose" -ge "1" ]; then
		test=""
		test=`awk '/^[ \t]*MODULE_REGISTER\(.*\).*/' $file`
		if [ "$test" != "" ]; then
			if [ "$verbose" = "1" ]; then
				echo -n "Scanning $file: "
			fi
			echo "Module";
		elif [ "$verbose" -ge "2" ]; then
			echo "ignored";
		fi
	fi
done
	
